"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var useFocusEffect;
try {
    useFocusEffect = require("@react-navigation/native").useFocusEffect;
}
catch (error) {
    useFocusEffect = null;
}
var Post = function (_a) {
    var item = _a.item, index = _a.index, isVisible = _a.isVisible, isCentered = _a.isCentered, _b = _a.renderItem, renderItem = _b === void 0 ? function () { } : _b, autoPlay = _a.autoPlay;
    var _c = (0, react_1.useState)(autoPlay ? !isCentered || !isVisible : true), paused = _c[0], setPaused = _c[1];
    (0, react_1.useEffect)(function () {
        setPaused(autoPlay ? !isCentered || !isVisible : true);
    }, [isCentered, isVisible]);
    return <>{renderItem({ item: item, index: index, paused: paused, setPaused: setPaused, isVisible: isVisible })}</>;
};
function VideoFlatList(_a) {
    var data = _a.data, renderItem = _a.renderItem, _b = _a.itemVisiblePercentThreshold, itemVisiblePercentThreshold = _b === void 0 ? 75 : _b, _c = _a.autoPlay, autoPlay = _c === void 0 ? true : _c, props = __rest(_a, ["data", "renderItem", "itemVisiblePercentThreshold", "autoPlay"]);
    var _d = (0, react_1.useState)(null), centeredItem = _d[0], setCenteredItem = _d[1];
    var _e = (0, react_1.useState)(true), isScreenFocused = _e[0], setIsScreenFocused = _e[1];
    var useCustomFocusEffect = function (callback) {
        if (typeof useFocusEffect === "function") {
            useFocusEffect(callback);
        }
    };
    useCustomFocusEffect(react_1.default.useCallback(function () {
        setIsScreenFocused(true);
        return function () {
            setIsScreenFocused(false);
        };
    }, []));
    var onViewableItemsChanged = (0, react_1.useRef)(function (_a) {
        var viewableItems = _a.viewableItems;
        if (viewableItems.length > 0) {
            var centerItem = viewableItems.find(function (item) { return item.isViewable && item.item.id === centeredItem; });
            if (!centerItem) {
                var newCenterItem = viewableItems.reduce(function (prev, current) {
                    return Math.abs(current.percentVisible - 100) <
                        Math.abs(prev.percentVisible - 100)
                        ? current
                        : prev;
                });
                setCenteredItem(newCenterItem.item.id);
            }
        }
        else {
            setCenteredItem(null);
        }
    });
    var viewabilityConfig = (0, react_1.useRef)({
        itemVisiblePercentThreshold: itemVisiblePercentThreshold,
        minimumViewTime: 300,
    });
    var renderItemFlatList = function (_a) {
        var item = _a.item, index = _a.index;
        return (<Post item={item} isVisible={isScreenFocused} isCentered={centeredItem === item.id && isScreenFocused} index={index} renderItem={renderItem} autoPlay={autoPlay}/>);
    };
    return (<react_native_1.FlatList {...props} data={data} renderItem={renderItemFlatList} keyExtractor={function (_, i) { return i.toString(); }} onViewableItemsChanged={onViewableItemsChanged.current} viewabilityConfig={viewabilityConfig.current}/>);
}
exports.default = VideoFlatList;
